package com.brainoff {

	
	public class W3CDateTime extends Date {
		
		public function W3CDateTime(dateString:String){
		
			
			if(dateString != undefined)
			{
				setDateTimeString(dateString);
				}
			
			
		}
		public function setDateTimeString(dateString:String):void{
		
			
			//this.dateString = dateString;
			setTime(W3CDateTime.parseString(dateString).getTime());
			
			
		}
		public function getDateTimeString(incMonth:Boolean, incDay:Boolean, incHours:Boolean, incSeconds:Boolean):String{
		
			
			return W3CDateTime.parseDate(this, incMonth, incDay, incHours, incSeconds);
			
			
		}
		public function toString(Void:Object):String{
		
			
			return getDateTimeString(true, true, true, true);
			
			
		}
		public function getW3CYear(Void:Object):String{
		
			
			return getFullYear().toString();
			
			
		}
		public function getW3CMonth(Void:Object):String{
		
			
			return (getMonth() + 1).toString();
			
			
		}
		public function getW3CDate(Void:Object):String{
		
			
			return getDate().toString();
			
			
		}
		public function getW3CHours(Void:Object):String{
		
			
			//adjust for utc?
			return getHours().toString();
			
			
		}
		public function getW3CMinutes(Void:Object):String{
		
			
			return getMinutes().toString();
			
			
		}
		public function getW3CSeconds(Void:Object):String{
		
			
			return getMinutes().toString();
			
			
		}
		public function getW3CUTCOffset(Void:Object):String{
		
			
			return W3CDateTime.formatTimezoneOffset(this);
			
			
		}
		public static function padDigit(digit:String):String{
		
			
			if(digit.length < 2)
			{
				return "0" + digit;
				}
			
			return digit;
			
			
		}
		public static function parseDate(inDate:Date, incMonth:Boolean, incDay:Boolean, incHours:Boolean, incSeconds:Boolean):String{
		
			
			if(inDate == undefined)
			{
				return undefined;
				}
			
			if(incMonth == undefined)
			{
				incMonth = false;
				}
			
			if(incDay == undefined)
			{
				incDay = false;
				}
			
			if(incHours == undefined)
			{
				incHours = false;
				}
			
			if(incSeconds == undefined)
			{
				incSeconds = false;
				}
			
			var now:Date = new Date();
			
			var w3cString:String = now.getFullYear().toString();
			
			if(!incMonth)
			{
				return w3cString;
				}
			
			w3cString += "-" + W3CDateTime.padDigit((now.getMonth() + 1).toString());
			
			if(!incDay)
			{
				return w3cString;
				}
			
			w3cString += "-" + W3CDateTime.padDigit(now.getDate().toString());
			
			if(!incHours)
			{
				return w3cString;
				}
			
			w3cString += "T" + W3CDateTime.padDigit(now.getHours().toString()) +
			":" + W3CDateTime.padDigit(now.getMinutes().toString());
			
			if(!incSeconds)
			{
				//need to format the timeset appropriately
				return w3cString + W3CDateTime.formatTimezoneOffset(now);
				}
			
			return w3cString + ":" + W3CDateTime.padDigit(now.getSeconds().toString()) +
			W3CDateTime.formatTimezoneOffset(now);
			
			
		}
		public static function formatTimezoneOffset(d:Date):String{
		
			
			var timezoneOffset:Number = d.getTimezoneOffset();
			
			if(timezoneOffset == 0)
			{
				return "Z";
				}
			
			var operator:String = (timezoneOffset > -1)? "+" : "-";
			
			if(timezoneOffset < 0)
			{
				timezoneOffset *= -1;
				}
			
			//what if offset if 0 or less
			var hours:String = (timezoneOffset / 60).toString();
			var seconds:String = (timezoneOffset - (hours * 60)).toString();
			
			return operator + W3CDateTime.padDigit(hours) +
			":" + W3CDateTime.padDigit(seconds);
			
			
		}
		public static function parseString(dateString:String):Date{
		
			
			if(dateString == undefined || dateString.length < 1)
			{
				return undefined;
				}
			
			var YYYY:String = dateString.substr(0, 4);
			var MM:String = dateString.substr(5, 2);
			var DD:String = dateString.substr(8, 2);
			var hh:String = dateString.substr(11, 2);
			var mm:String = dateString.substr(14, 2);
			var ss:String = dateString.substr(17, 2);
			var s:String = "";
			
			var offsetOperator:String;
			var offsetHours:String;
			var offsetMinutes:String;
			
			var offset:Number = 0;
			var operator:Number;
			var indexBump:Number = 0;
			
			if(dateString.substr(19, 1) == ".")
			{
				//they have a decimal second
				s = dateString.substr(20, 2);
				
				indexBump = 3;
				}
			else if (ss == "") { //can have tz offset with no seconds
				indexBump = -2;
				}
			else
			{
				indexBump = 0;
				//they dont have a decimal second
				}
			
			offsetOperator = dateString.substr(19 + indexBump,1);
			offsetHours = dateString.substr(20 + indexBump,2);
			offsetMinutes = dateString.substr(23 + indexBump,2);
			
			//this could be wrong if there is no operator
			operator = ((offsetOperator == "-") || (offsetOperator == undefined))? 1 : -1;
			
			//this could be wrong if offsethours or offsetminutes is undefined
			offset = operator * (Number(offsetHours) * 60) + Number(offsetMinutes);
			
			if(isNaN(offset))
			{
				offset = 0;
				}
			
			var minutes:Number;
			if(mm != "")
			{
				minutes = Number(mm) + offset;
				}
			
			var month:Number;
			if(MM != "")
			{
				month = Number(MM) - 1;
				}
			
			var year:Number;
			if(YYYY != "")
			{
				year = Number(YYYY);
				}
			
			var day:Number;
			if(DD != "")
			{
				day = Number(DD);
				}
			
			var hours:Number;
			if(hh != "")
			{
				hours = Number(hh);
				}
			
			var seconds:Number;
			if(ss != "")
			{
				seconds = Number(ss);
				}
			
			var utcTimeMS = Date.UTC(
			year,
			month,
			day,
			hours,
			minutes,
			seconds);
			
			return new Date(utcTimeMS);;
			
			
		}
		
	}
	
}
