package com.brainoff {

	import com.brainoff.worldkitConfig;
	import com.brainoff.worldkitInteraction;
	import com.brainoff.worldkitImages;
	import com.brainoff.worldkitMain;
	import com.brainoff.worldkitRSS;
	import com.brainoff.worldkitUtil;
	import as2.toplevel.MovieClip;
	
	public class worldkitAnnotation {
		
		private var main:worldkitMain;
		private var conf:worldkitConfig;
		private var rss:worldkitRSS;
		private var interact:worldkitInteraction;
		private var img:worldkitImages;
		private var mc:MovieClip;
		private var depth:Number;
		private var title:String;
		private var url:String;
		private var lat:Number;
		private var lon:Number;
		private var summary:String;
		private var cats:Array;
		private var id:String;
		private var photo:String;
		private var prevlat:Number;
		private var prevlon:Number;
		private var vector:String;
		private var vtype:String;
		private var datestring:String;
		private var date:Date;
		private var precompile:Boolean;
		private var enddate:Date;
		public var present:Boolean;
		public var activate:Boolean;
		private var clipname:String;
		private var textname:String;
		private var x:Number;
		private var y:Number;
		private var prevx:Number;
		private var prevy:Number;
		private var scale:Number;
		private var jsargs:String;
		private var color:Number;
		private var createdate:Date;
		private var initialplotcolor:Number;
		private var restingplotcolor:Number;
		private var activatecolor:Number;
		private var plotsize:Number;
		private var plotshape:String;
		private var icon:String;
		private var linecolor:Number;
		private var zoomto:Number;
		private var linealpha:Number;
		private var linethickness:Number;
		private var fillalpha:Number;
		private var window:String;
		private var rssicon:String;
		private var curralpha:Number;
		private var colorobj:Color;
		public function worldkitAnnotation(main:worldkitMain, mc:MovieClip, depth:Number, title:String, url:String, lat:Number, lon:Number, summary:String, cats:Array, id:String, photo:String, prevlat:Number, prevlon:Number, vector:String, vtype:String, datestring:String, precompile:Boolean, enddate:String, rssicon:String){
		
			
			
			this.main = main;
			this.mc = mc;
			
			conf = main.getConfig();
			rss = main.getRSS();
			interact = main.getInteract();
			img = main.getImages();
			
			this.depth = depth;
			this.title = title;
			this.url = url;
			this.lat = lat;
			this.lon = lon;
			this.summary = summary;
			this.cats = cats;
			this.id = id;
			this.photo = photo;
			this.prevlat = prevlat;
			this.prevlon = prevlon;
			this.vector = vector;
			this.vtype = vtype;
			this.datestring = datestring;
			this.date = new Date(worldkitUtil.parseDate(datestring));
			this.precompile = precompile;
			if (enddate != undefined) {
				this.enddate = new Date(worldkitUtil.parseDate(enddate));
				}
			this.rssicon = rssicon;
			
			present = true;
			activate = false;
			
			setparams();
			
			if (this.precompile == undefined) {
				clipname = this.depth + "point";
				textname = this.depth + "pointtext";
				mc.createEmptyMovieClip(clipname,this.depth);
				} else {
				clipname = this.title;
				textname = this.title + "text";
				}
			
			if (this.precompile) {
				colorobj = new Color(mc[ this.clipname ]);
				}
			
			createdate = new Date();
			curralpha = 100;
			mc[this.clipname].annotation = this;
			
			
		}
		public function setparams():void{
		
			
			initialplotcolor = conf.getConfBySubject("initialplotcolor", this.cats);
			restingplotcolor = conf.getConfBySubject("restingplotcolor", this.cats);
			activatecolor = conf.getConfBySubject("activatecolor", this.cats);
			plotsize = conf.getConfBySubject("plotsize", this.cats);
			plotshape = conf.getConfBySubject("plotshape", this.cats);
			icon = conf.getMatchingSubject("icon", this.cats);
			linecolor = conf.getConfBySubject("linecolor", this.cats);
			zoomto = conf.getConfBySubject("zoomto", this.cats);
			linealpha = conf.getConfBySubject("linealpha", this.cats);
			linethickness = conf.getConfBySubject("linethickness", this.cats);
			fillalpha = conf.getConfBySubject("fillalpha", this.cats);
			window = conf.getConfBySubject("window", this.cats);
			
		}
		public function plot():void{
		
			
			if  (precompile != true && conf.accuplot != true) {
				/**/
				//reset scaling for plot
				/**/
				mc._x = 0; mc._y = 0; mc._xscale = 100; mc._yscale = 100;
				}
			
			if (precompile != true) {
				/**/
				// Calculate positions
				/**/
				var a = new Array();
				a = interact.geo2xy(lat,lon,true); x = a[0]; y = a[1];
				if (x == undefined || y == undefined) { return; }
				if (conf.track && prevlat != undefined && prevlon != undefined) {
					a = interact.geo2xy(prevlat,prevlon); prevx = a[0]; prevy = a[1];
					}
				mc[clipname]._x = x; mc[clipname]._y = this.y;
				
				var rescale = 100/interact.scale;
				scale = rescale;
				if (vector == undefined && precompile != true && conf.accuplot != true) {
					mc[clipname]._xscale = rescale;
					mc[clipname]._yscale = rescale;
					} else if (conf.accuplot == true) {
					scale = 100 * 100 /conf.h;
					mc[clipname]._xscale = scale;
					mc[clipname]._yscale = scale;
					}
				}
			
			jsargs = buildJsArgs();
			
			makeText();
			
			mc[clipname].onRelease = function() { this.annotation.onRelease(); }
			mc[clipname].onRollOver = function() { this.annotation.onRollOver();}
			mc[clipname].onRollOut = function() { this.annotation.onRollOut(); }
			
			setVisible(true,conf.textinterval);
			
			shape(1);
			
			if (initialplotcolor != restingplotcolor) {
				worldkitUtil.setTimeout(this, "shape", 60000, 2);
				}
			
			if (precompile != true && conf.accuplot != true) {
				interact.scaleAndPosition(mc,undefined);
				}
			
			
			if (conf.newitemcallback) {
				var msg = "title=" + escape(title) + "&url=" + escape(url) +  "&summary=" + escape( summary.split("\"").join("\\\"") ) +  "&lat=" + escape(String(lat)) + "&lon=" + escape(String(lon)) + "&id=" + escape(id);
				interact.processClick("", "_" + conf.newitemcallback, msg);
				}
			
			
		}
		public function makeText():void{
		
			
			if (conf.singletextfield != true) {
				mc.createEmptyMovieClip(textname, depth+10000); //REVISIT places 10000 plot limit
				mc[ textname ].annotation = this;
				mc[ textname ]._visible = 0;
				
				var w = mc.origwidth; var h = mc.origheight;
				var textx = x; var texty = y;
				var rescale = (100/interact.scale);
				var textboxsize = conf.textboxsize;
				if (precompile) {
					rescale = rescale * (w/conf.h);
					textboxsize = textboxsize * (100/conf.h);
					}
				// should maybe try to position this to the right of the point, or dynamically dependent on zoom)
				if (w - x < textboxsize) { textx = x - (textboxsize / interact.scale); }
				if (h - y < 100) { texty = y - (50 / interact.scale); }
				
				mc[ textname ]._x = textx; if (textx != x) { mc[textname].leftpos = true; }
				mc[ textname ]._y = texty; if (texty != y) { mc[textname].bottompos = true; }
				
				
				mc[textname]._xscale = scale;
				mc[textname]._yscale = scale;
				
				if (photo != "" && photo != undefined) {
					mc[textname].createEmptyMovieClip("image",100000); //REVISIT 100000
					mc[textname].image.loadMovie(photo);
					} else {
					var htmlText = "<font color=\"#555555\" face=\"Verdana,Arial,_sans\" size=\"" + conf.textsize + "\"><b>" + title + "</b><br>" + summary + "</font>";
					var textheight = 100;
					if (conf.textboxsize != 0) {
						mc[textname].createTextField("text",1,0,0,textboxsize,textheight);
						mc[textname].text.html = true; //REVISIT this might be trouble with non-roman chars
						mc[textname].text.multiline = true;
						mc[textname].text.wordWrap = true;
						mc[textname].text.border = true;
						mc[textname].text.autoSize ="center";
						mc[textname].text.background = true;
						mc[textname].text.backgroundColor = 0xFFFFFF;
						mc[textname].text.htmlText = htmlText;
						}
					}
				
				mc[textname].onRelease = function() { this.annotation.onReleaseText(); }
				}
			
			
			
		}
		private function shape(time:Number):void{
		
			
			if (mc[clipname] == undefined) { return; }
			
			mc[clipname].clear();
			
			if (time == 3) { color = activatecolor; }
			else if (time == 1) { color = initialplotcolor; }
			else { color = restingplotcolor; }
			
			if (precompile == true) {
				colorobj.setRGB( color );
				} else if (vtype == "poly") {
				drawpoly();
				} else if (vtype == "line") {
				drawline();
				} else if (vtype == "box") {
				drawbox();
				} else if (rssicon != undefined && rssicon != "") {
				if (time == 1) {
					loadrssicon();
					} else {
					activateicon(time);
					}
				} else if (icon != undefined && icon != "") {
				if (time == 1) {
					loadicon();
					}
				} else if (plotshape == "square") {
				square();
				} else if (plotshape == "circle") {
				circle();
				} else if (plotshape == "triangle") {
				triangle();
				}
			
			tracks();
			
			
			
		}
		private function drawpoly():void{
		
			
			var polyarray = vector.split(" ");
			var xy,x,y;
			
			mc[clipname].lineStyle( linethickness, linecolor, linealpha);
			for (var i=0; i<polyarray.length-1; i+=2) {
				xy = interact.geo2xy(polyarray[i],polyarray[i+1]);
				x = xy[0] - mc[clipname]._x; //need to adjust geo2xy
				y = xy[1] - mc[clipname]._y; //relative to movie clip position
				if (i == 0) {
					mc[clipname].moveTo(x,y);
					mc[clipname].beginFill( color, fillalpha );
					} else {
					mc[clipname].lineTo(x,y);
					}
				}
			mc[clipname].endFill();
			
			
		}
		private function drawbox():void{
		
			
			var boxarray = vector.split(" ");
			if (boxarray.length == 4) {
				vector = boxarray[0] + " " + boxarray[1] + " " + boxarray[0] + " " + boxarray[3] + " " + boxarray[2] + " " + boxarray[3] + " " + boxarray[2] + " " + boxarray[1] + " " + boxarray[0] + " " + boxarray[1];
				vtype = "poly";
				drawpoly();
				}
			
			
		}
		private function drawline():void{
		
			
			var linearray = vector.split(" ");
			var l;
			var xy,x,y;
			
			mc[clipname].lineStyle( linethickness, linecolor, linealpha);
			for (var i=0; i<linearray.length-1; i+=2) {
				xy = interact.geo2xy(linearray[i],linearray[i+1]);
				x = xy[0]  - mc[clipname]._x; //need to adjust geo2xy
				y = xy[1]  - mc[clipname]._y; //relative to movie clip position
				if (i == 0) {
					mc[clipname].moveTo(x,y);
					} else {
					mc[clipname].lineTo(x,y);
					}
				}
			
			
		}
		private function square():void{
		
			
			var x = 0; var y = 0; //movie clip is already positioned
			var s = plotsize;
			mc[clipname].lineStyle( linethickness, linecolor, linealpha );
			mc[clipname].moveTo(x-s,y-s);
			mc[clipname].beginFill( color, fillalpha );
			mc[clipname].lineTo(x-s,y+s);
			mc[clipname].lineTo(x+s,y+s);
			mc[clipname].lineTo(x+s,y-s);
			mc[clipname].lineTo(x-s,y-s);
			mc[clipname].endFill();
			
			
		}
		private function circle():void{
		
			
			var x = 0; var y = 0; //movie clip is already positioned
			var s = plotsize;
			mc[clipname].lineStyle( linethickness, linecolor, linealpha );
			mc[clipname].moveTo(x+s,y); //move to point on the circle to drawArc
			mc[clipname].beginFill( color, fillalpha );
			mc[clipname].drawArc(x+s,y,s,360,0);
			mc[clipname].endFill();
			
			
		}
		private function triangle():void{
		
			
			var x = 0; var y = 0; //movie clip is already positioned
			var s = plotsize;
			mc[clipname].lineStyle( linethickness, linecolor, linealpha );
			mc[clipname].moveTo(x /*Math.cos(Math.PI / 2)*/,
			y - s /*Math.sin(Math.PI / 2)*/);
			mc[clipname].beginFill( color );
			//this.datalayer[this.clipname].lineTo(x + s * -0.86603 /*Math.cos(Math.PI * 7 / 6)*/,
			//		      y - s * -0.5 /*Math.sin(Math.PI * 7 / 6)*/ );
			//this.datalayer[this.clipname].lineTo(x - s * 0.86603 /*Math.cos(Math.PI * 11 / 6)*/,
			//		      y - s * -0.5 /*Math.sin(Math.PI * 11 / 6)*/ );
			mc[clipname].lineTo(x+s,y+s);
			mc[clipname].lineTo(x-s,y+s);
			mc[clipname].lineTo(x,y - s);
			mc[clipname].endFill();
			
			
		}
		private function loadicon():void{
		
			
			if (mc[clipname]["icon"] == undefined) {
				mc[clipname].createEmptyMovieClip("icon",1);
				}
			if (! img.loadicon(mc[clipname]["icon"], "icon" + icon)) {
				worldkitUtil.setTimeout(this, "loadicon", 1000);
				}
			
			
		}
		private function loadrssicon():void{
		
			
			if (mc[clipname]["icon"] == undefined) {
				mc[clipname].createEmptyMovieClip("icon",1);
				}
			if (! img.loadrssicon(mc[clipname]["icon"], rssicon)) {
				worldkitUtil.setTimeout(this, "loadrssicon", 1000);
				}
			
			
		}
		public function activateicon(time:Number){
		
			
			if (mc[clipname]["icon"] == undefined) {
				return;
				}
			var iconwidth;
			var alpha = 100;
			if (time == 2) {
				iconwidth = conf.rssiconwidth;
				alpha = curralpha;
				} else if (time == 3) {
				iconwidth = conf.rssiconwidth * 1.5;
				}
			img.activateicon(mc[clipname]["icon"], rssicon, iconwidth);
			mc[clipname]["icon"]._alpha = alpha;
			
			
		}
		private function tracks():void{
		
			
			if (conf.track && prevx != undefined && prevy != undefined) {
				var layer;
				if (conf.trackcats) {
					if (mc.tracks[ cats[0] ] == undefined) {
						mc.tracks.createEmptyMovieClip( cats[0], mc.tracks.tracklayer );
						mc.tracks.tracklayer++;
						}
					layer = mc.tracks[ cats[0] ];
					
					} else {
					layer = mc;
					}
				
				layer.lineStyle( linethickness, linecolor, linealpha );
				layer.moveTo(mc[clipname]._x, mc[clipname]._y);
				layer.lineTo(prevx,prevy);
				}
			//rss.setTrackVis();
			//	worldkitAnnotationClass.setTrackVis(this.conf, this.datalayer);
			
			
		}
		private function buildJsArgs():String{
		
			
			return "link=" + escape(url) + "&lat=" + escape(String(lat)) + "&long=" + escape(String(lon)) + "&id=" + escape(id);
			
			
		}
		public function setLoc():void{
		
			
			var a = interact.geo2xy(lat, lon, true);
			x = a[0]; y = a[1];
			if (x == undefined || y == undefined) { return; }
			mc[clipname]._x = x; mc[clipname]._y = y;
			mc[textname]._x = x; mc[textname]._y = y;
			
			
		}
		public function setVisible(forcetext:Boolean, textvis:Number):void{
		
			
			//accurate -- might also just call this, or make another function for repositioning
			var visible = true;
			
			for (var s in cats) {
				if (conf.categories[ cats[s] ] == false) {
					visible = false;
					}
				}
			
			if (conf.timenav != false) {
				if (conf.neartime) {
					if (Math.abs(interact.maxtime - date) > conf.neartime) {
						visible = false;
						}
					} else {
					if (enddate != undefined) {
						if (enddate < interact.maxtime) {
							visible = false;
							}
						}
					if (date > interact.maxtime) {
						visible = false;
						}
					}
				}
			
			if (visible) {
				if (mc[clipname]._visible == 0 || forcetext) {
					mc[clipname]._visible = 1;
					if (textvis > 0) {
						mc[textname]._visible = 1;
						worldkitUtil.setTimeout(this,"hidetext",textvis);
						}
					}
				} else {
				mc[clipname]._visible = 0;
				mc[textname]._visible = 0;
				}
			
			
		}
		public function setActivate(cat:String):void{
		
			
			var hit = false;
			for (var s in cats) {
				if (cats[s] == cat) {
					hit = true;
					}
				}
			
			if (hit) {
				if (activate == true) {
					activate = false;
					shape(2);
					} else {
					activate = true;
					shape(3);
					}
				}
			
			
		}
		public function forceActivate():void{
		
			
			if (activate == true) {
				activate = false;
				shape(2);
				} else {
				activate = true;
				shape(3);
				}
			
			
		}
		public function setAlphaFade(now:Date):void{
		
			
			if (curralpha == -1) { return; }
			var s = (now - createdate) / 1000;
			var clip;
			if (mc[clipname]["icon"]) {
				clip = mc[clipname]["icon"];
				} else {
				clip = mc[clipname];
				}
			clip._alpha = 100 - 100 * (s / conf.fade);
			curralpha = clip._alpha;
			
			if (curralpha <= 0) {
				if (mc[clipname]["icon"]) {
					mc[clipname]["icon"].removeMovieClip();
					mc[clipname]["icon"] = 1;
					} else {
					mc[clipname].clear();
					}
				if (conf.fadeditemcallback) {
					var msg = "&id=" + escape(id);
					interact.processClick("", "_" + conf.fadeditemcallback, msg);
					}
				curralpha = -1;
				}
			
			
		}
		public function hidetext():void{
		
			
			if (conf.singletextfield != true) {
				mc[textname]._visible = 0;
				} else {
				interact.LoadingDialog(undefined, true);
				}
			
			
		}
		public function showtext(setActive:Boolean):void{
		
			
			if (conf.singletextfield != true) {
				if (setActive) {
					rss.setActive(this);
					}
				
				var ratio = conf.w / conf.h;
				var stagew, stageh, textx, texty;
				if (ratio > 1) { stagew  = 100 * ratio; stageh = 100; }
				else { stageh = 100 / ratio; stagew = 100; }
				
				var mousex = conf.w * (_root._xmouse / stagew);
				var mousey = conf.h * (_root._ymouse / stageh);
				
				if (mc.origwidth - mousex < conf.textboxsize) { textx = mousex - (conf.textboxsize / interact.scale); }
				if (mc.origheight - y < 100) { texty = mousey - (50 / interact.scale); }
				
				mc[ textname ]._x = textx; if (textx != x) { mc[textname].leftpos = true; }
				mc[ textname ]._y = texty; if (texty != y) { mc[textname].bottompos = true; }
				
				mc[ textname ]._visible = 1;
				} else {
				interact.LoadingDialog( title, true, 10);
				}
			
			
		}
		public function onRollOver():void{
		
			
			showtext(true);
			
			
		}
		public function onRollOut():void{
		
			
			worldkitUtil.setTimeout(this,"hidetext",conf.visinterval);
			
			
		}
		public function onRelease():void{
		
			
			if (zoomto != undefined) {
				interact.zoomTo(lat, lon, zoomto);
				} else {
				interact.cautiousProcessClick(url,window,jsargs);
				}
			
			
		}
		public function onReleaseText():void{
		
			
			if (zoomto != undefined) {
				interact.zoomTo(lat, lon, zoomto);
				} else {
				interact.cautiousProcessClick(url,window,jsargs+"&text=1");
				}
			
			
		}
		public function clear():void{
		
			
			mc[clipname].removeMovieClip();
			mc[textname].removeMovieClip();
			
			
		}
		public function changed(title:String, url:String, lat:Number, lon:Number, summary:String, cats:Array, photo:String, vector:String, vtype:String, datestring:String):Boolean{
		
			
			var changed = false;
			if (title != this.title) { this.title = title; changed = true; }
			if (url != this.url) { this.url = url; changed = true; }
			if (lat != this.lat) { this.lat = lat; changed = true; }
			if (lon != this.lon) { this.lon = lon; changed = true; }
			if (summary != this.summary) { this.summary = summary; changed = true; }
			if (cats.join(':') != this.cats.join(':')) { this.cats = cats; changed = true; }
			if (photo != this.photo) { this.photo = photo; changed = true; }
			if (vector != this.vector) { this.vector = vector; changed = true; }
			if (vtype != this.vtype) { this.vtype = vtype; changed = true; }
			if (datestring != this.datestring) {this.date = new Date(worldkitUtil.parseDate(datestring)); changed = true; } //REVISIT work??
			
			return changed;
			
			
		}
		public function clearMC():void{
		
			
			if (precompile != true) {
				mc[ clipname ].clear();
				mc[ textname ].removeMovieClip();
				}
			
			
		}
		public function GetItem():void{
		
			
			var s = "||";
			var catstring = cats.join(",");
			var coords;
			if (vtype == "poly" || vtype == "line") {
				coords = vector;
				} else {
				coords = String(lat) + "," + String(lon);
				}
			var args = title + s + url + s + summary + s + catstring + s + coords + s + vtype;
			interact.annotate(null,null,args);
			
			
		}
		
	}
	
}
